<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Cookie;
use Illuminate\Support\Facades\Session;



class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //Session::flash('clef', 'valeurs');
        
        dd(Session::get('clef'));
        //$users = DB::select('select * from users' );


       // dd($users);
        // $user = DB::select('select * from users where name = "sdqdqdqdqdqdsq"');
        // dd($user);
       
        //return redirect()->route('check');

    // On retourne les informations des utilisateurs en JSON
        
    //return 'test';
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
       
        // $validated = $request->validate([
        //     'name' => 'required|max:255',
        //     'prenom' => 'required|max:255',
        //     'email' => 'required|email',
        //     'password' => 'required'

        // ]);
        //dd(Cookie::get('user'));
        $user = [
            'name' => $request->name,
            'prenom' => $request->prenom,
            'email' => $request->email,
            'password'=> Hash::make($request->password),
        ];
        $user = User::create($user);
        return response()->json($user, 201);
        //return $request;
    

    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function show($user)
    {
        //affichage des article dun utilisateur specifique
        $arc = DB::select('select * from users WHERE id = :id',['id' => $user] );
        return response()->json($arc, 201);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $user)
    {
        $usr = User::find($user);
        $usr->email = $request->email;
        $usr->name = $request->name;
        $usr->prenom = $request->prenom;

        $usr->save();

        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function destroy(User $user)
    {

        //
        //$user->delete();

    }

    public function deleteall(User $user) {
        $user->delete();
    }

    public function checkuser(Request $request) {

            //if (empty($user)) dd("fail"); else dd($user);
        $hachpassword = DB::select('select password from users WHERE email = :email',['email' => $request->email] );
        $id = DB::select('select id from users WHERE email = :email',['email' => $request->email] );
        $name = DB::select('select name from users WHERE email = :email',['email' => $request->email] );
        //$kk = Hash::make($hachpassword[0]->password);
        $combin = [
            $id,
            $name,
        ];
        if (Hash::check($request->password, $hachpassword[0]->password )) {
            // $minute = 5;
            // $response = new Response('Hello World');
            // $response->withCookie(cookie()->forever('user', 'love u'));
            return response($combin, 200);
            
        }
        return response('erreur', 504);
       
        
        
    }

  

    

    
}
