<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\API\UserController;
use App\Http\Controllers\API\ArticleController;


/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});

Route::apiResource('/loginApi', UserController::class );

Route::apiResource('/articleApi', ArticleController::class );

// Route::post('/register', [UserController::class, 'store']);

Route::delete('/delete', [UserController::class, 'deleteall']);

Route::post('/check', [UserController::class, 'checkuser']);

Route::get('/get_article/{id}', [ArticleController::class, 'get_article']);


// Route::get('/user', function() {
//     return 'test';
// });

// Route::get('/set-cookie', function() {
//     $response = new Illuminate\Http\Response();

//     $response->cookie('test5', 'zz',5, '/', '   127.0.0.1'); // this will last five years
//     dd($response);
//     return $response;
// });

// Route::get('/get-cookie', function() {
//    //
//    $res = new Response("test");

//    $res->data = "qsdq"; // showing you different ways to set / get the cookie
//    return $res;
// });