import Vue from 'vue'
import VueRouter from 'vue-router'
import home from '../views/home.vue'
import article from '../views/article.vue'
import acceuil from '../views/acceuil.vue'
import login from '../views/login.vue'
import signup from '../views/sign_up.vue'
import info from '../views/info.vue'
import add_article from '../views/ajout_article.vue'
import affich_article from '../views/affich_article.vue'
import article_other from '../views/article_other.vue'



Vue.use(VueRouter)
// eslint-disable-next-line 

const routes = [

    {
        path: '/home',
        name: 'home',
        component: home
    },

    {
        path: '/my_article',
        name: 'article',
        component: article
    },

    {
        path: '/',
        name: 'acceuil',
        component: acceuil
    },
   
    {
        path: '/login',
        name: 'login',
        component: login
    },
    {
        path: '/signup',
        name: 'signup',
        component: signup
    },

    {
        path: '/info',
        name: 'info',
        component: info
    },

    {
        path: '/add_article',
        name: 'add_article',
        component: add_article
    },
    {
        path: '/affich_article',
        name: 'affich_article',
        component: affich_article
    },

    {
        path: '/article_other',
        name: 'article_other',
        component: article_other
    },
    

]

const router = new VueRouter({
    mode : 'history',
    base: process.env.BASE_URL,
    routes
})

export default router